
/* everything will probably want these somewhere, toss them on top
   just in case. */

#include <stdio.h>
#include <curses.h>
#include <stdarg.h>
#include <string.h>

/* and the necessary local includes. */

#include <bbsglob.h>
#include <bbsdefs.h>
#include <messages.h>
#include <nodelist.h>
#include <fileareas.h>
#include <db_iface.h>

/* functions from cli_users.c...  guess what they do. :) */

BBS_User *read_user(char *handle);
BBS_User *read_userlist(int *len);
int update_user(BBS_User *user);
int clear_user(char *handle);
void e_mail_scan(BBS_User *user);

/* functions from cli_nodes.c...  yet another guess. */

BBS_Node *read_node(int node);
int update_node(BBS_Node *node);
int clear_node(int node);
int login_node(char *login, char *password);

/* cli_misc.c, these are good, old-fashioned client functions that
   didn't have anywhere else to live. */

BBS_Menu *read_menu (char *menuname);
int log (char *fmt, ...);
int reload_db(void);

/* cli_net.c, the networking functions which the DB server wouldn't
   need. */

int db_conn(DB_Req *req);
int db_reply(int db_sock);
int big_read(int sock, void *dump, int len);

/* cli_nodelist.c, the nodelist 2000 access functions. */

tConnect *read_nl2k(tAddress *lookup, char *type);
char *name_nl2k(tAddress *lookup);

/* cli_msgs.c, which does the more primative messaging stuff. */

MSG_Area *all_areas(void);
MSG_Net *all_nets(void);
MSG_Area *read_area(char *area);
MSG_Net *read_net(char *name);
char *read_message(MSG_Ref *lookup, MSG_Head *head);
int write_message(MSG_Ref *where, MSG_Head *head, char *body);
int clear_message(MSG_Ref *where);
int update_pointer(char *handle, char *area, int msg);
int read_pointer(char *handle, char *area);
int clear_pointer(char *handle, char *area);
MSG_Net *net_by_addr(char *addr);
int tr_off(MSG_Ref *lookup);
MSG_Head *get_head(MSG_Ref *lookup);
MSG_Net *read_net_num(int netid);

/* cli_files.c, file areas */

FILE_Area *file_area(char *area);
FILE_Area *file_arealist(int *len);
int file_info(FILE_Info *lookup);
FILE_Info *file_list(char *area, int *len);
int file_add(FILE_Info *info);
int file_clear(FILE_Info *info);
FILE_Proto *file_protos(int *len);
FILE_Area *file_nextarea(FILE_Area *cur);
FILE_Area *file_prevarea(FILE_Area *cur);
