#include <sys/types.h>

/* Below, we define everything necessary to do n2000 compiled
   nodelists.  joy, oh, joy. */

/* Record used for the actual storage of an address. */

typedef struct _tAddress {
     u_int16_t Zone;
     u_int16_t Net;
     u_int16_t Node;
     u_int16_t Point;
     char Domain[11];
} tAddress;

/* Connection info */

typedef struct _tConnect {
     char SiteName[31]; /* System name */
     char SiteLoc[31]; /* Geographical Location */
     char SysName[31]; /* Sysop Name */
     char Connection[31]; /* depends. email addr, or ftp, or.. */
     char CapFlags[31]; /* capability flags */
} tConnect;

/* uhhhh.. */

/* this is the record number in whatever index file we mean when a record
   begins. */

typedef struct _tNLIdx {
     u_int16_t Zone; 
     u_int16_t Net;
     u_int16_t EmailIdx;
     u_int16_t FTPIdx;
     u_int16_t PhoneIdx;
     u_int16_t TelnetIdx;
     u_int16_t ISDNIdx;
     u_int16_t OtherIdx;
} tNLIdx;

typedef struct _tNLDat {
     tAddress Address;
     u_int16_t NodeFlags; /* 1 = zone coord, 2 = net coord */
     tConnect Connect;
} tNLDat;

typedef struct _tNLODat {
     tAddress Address;
     char ConnFlag[3]; /* actual 2-car connection flag. */
     u_int16_t NodeFlags;
     tConnect Connect;
} tNLODat;




