/* first, define some wrapper structs so we can work with all of this
   in memory without too much of a hassle. */

struct tNLDat_wrap {
     tNLDat *data;
     struct tNLDat_wrap *next;
};

struct tNLDat_owrap {
     tNLODat *data;
     struct tNLDat_owrap *next;
};

struct tNLIdx_wrap {
     tNLIdx *data;
     struct tNLIdx_wrap *next;
};

/* these are used to recognize what we're dealing with in some
   places. */

#define NL_EMAIL 0
#define NL_FTP 1
#define NL_PHONE 2
#define NL_TELNET 3
#define NL_ISDN 4

void compile_main(char **filenames, char *base);
void mangle_listfile(char *filename);
void sort_all_links(void);
void normal_sort(struct tNLDat_wrap **begin);
void other_sort(struct tNLDat_owrap **begin);
int addr_comp(tAddress *first, tAddress *second);
void build_index(char *base);
void write_normal(struct tNLDat_wrap *begin, char *filename);
void add_to_index(struct tNLIdx_wrap **begin, struct tNLDat_wrap *begin_entries, int type);
void add_to_index_other(struct tNLIdx_wrap **begin, struct tNLDat_owrap *begin_entries);
struct tNLIdx_wrap *find_index(struct tNLIdx_wrap *begin, tAddress *lookup);


